/***************************************************************************
****************************************************************************

This is a part of the xModule Source code.

Copyright (C) 2003-2009 The LS-Universe Team

  Homepage: http://www.ls-universe.info

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************
****************************************************************************/

#ifndef _GRADIENT_ELLIPTIC_H_
#define _GRADIENT_ELLIPTIC_H_

#include "Gradient.h"

#define SQF 181  // 181 * 181 * 2   = 65527
#define SQR 256  // sqrt(65527)     = 255.98
#define SQD  16
#define SQR_TAB_SIZE (SQF*SQF*2 / SQD) // ~ 4096

class GradientElliptic : public Gradient {
public:
    GradientElliptic(int width, int height, COLORREF startColor, COLORREF endColor);
protected:
    virtual void paintPixel(DWORD *p, int x, int y);
private:
    unsigned char _sqrt_table[SQR_TAB_SIZE];
    void init_sqrt();
};

#endif