/***************************************************************************
****************************************************************************

This is a part of the xModule Source code.

Copyright (C) 2003-2009 The LS-Universe Team

  Homepage: http://www.ls-universe.info

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************
****************************************************************************/

#include "stdafx.h"

#include "PaintTexture.h"
#include "PaintIcon.h"
#include "PaintText.h"
#ifdef HTMLTEXT_MFC
    #include "PaintHTMLText.h"
#endif
#include "PaintTooltip.h"

static bool bVersionExported = false;

PaintTexture *Create_xTextureClass()
{
    if ( !bVersionExported )
    {
        LSSetVariable("xPaintClassVersion", XPCVERSION);
        bVersionExported = true;
    }

    PaintTexture *getTextureClass = NULL;
    
    getTextureClass = new PaintTexture();

    return getTextureClass;
}

PaintIcon *Create_xIconClass()
{
    if ( !bVersionExported )
    {
        LSSetVariable("xPaintClassVersion", XPCVERSION);
        bVersionExported = true;
    }

    PaintIcon *getIconClass = NULL;
    
    getIconClass = new PaintIcon();

    return getIconClass;
}

PaintText *Create_xTextClass()
{
    if ( !bVersionExported )
    {
        LSSetVariable("xPaintClassVersion", XPCVERSION);
        bVersionExported = true;
    }

    PaintText *getTextClass = NULL;
    
    getTextClass = new PaintText();

    return getTextClass;
}

#ifdef HTMLTEXT_MFC
    PaintHTMLText *Create_xHTMLTextClass()
    {
        if ( !bVersionExported )
        {
            LSSetVariable("xPaintClassVersion", XPCVERSION);
            bVersionExported = true;
        }

        PaintHTMLText *getHTMLTextClass = NULL;
        
        getHTMLTextClass = new PaintHTMLText();

        return getHTMLTextClass;
    }
#endif

PaintTooltip *Create_xTooltipClass(HWND hWndParent, HINSTANCE hInstanceParent)
{
    if ( !bVersionExported )
    {
        LSSetVariable("xPaintClassVersion", XPCVERSION);
        bVersionExported = true;
    }

    PaintTooltip *getTooltipClass = NULL;
    
    getTooltipClass = new PaintTooltip(hWndParent, hInstanceParent);

    return getTooltipClass;
}

void Destroy_xTextureClass(PaintTexture *destroyTextureClass)
{
    if (destroyTextureClass)
        delete destroyTextureClass;

    destroyTextureClass = NULL;
}

void Destroy_xIconClass(PaintIcon *destroyIconClass)
{
    if (destroyIconClass)
        delete destroyIconClass;

    destroyIconClass = NULL;
}

void Destroy_xTextClass(PaintText *destroyTextClass)
{
    if (destroyTextClass)
        delete destroyTextClass;

    destroyTextClass = NULL;
}

#ifdef HTMLTEXT_MFC
    void Destroy_xHTMLTextClass(PaintHTMLText *destroyHTMLTextClass)
    {
        if (destroyHTMLTextClass)
            delete destroyHTMLTextClass;

        destroyHTMLTextClass = NULL;
    }
#endif

void Destroy_xTooltipClass(PaintTooltip *destroyTooltipClass)
{
    if (destroyTooltipClass)
        delete destroyTooltipClass;

    destroyTooltipClass = NULL;
}